import { inject as w, defineComponent as h, openBlock as R, createElementBlock as m, renderSlot as g, createTextVNode as k, computed as E, createCommentVNode as U, unref as I, ref as p } from "vue";
const v = Symbol("fusionAuth"), d = () => {
  const r = w(v);
  if (!r)
    throw new Error(
      "No FusionAuth instance found. Did you forget to call Vue.use(FusionAuthVuePlugin)?"
    );
  return r;
}, T = /* @__PURE__ */ h({
  __name: "FusionAuthLoginButton",
  props: {
    state: {}
  },
  setup(r) {
    const e = d(), t = r;
    function n() {
      e.login(t.state);
    }
    return (s, o) => (R(), m("button", {
      class: "login-button",
      onClick: o[0] || (o[0] = (u) => n())
    }, [
      g(s.$slots, "default", {}, () => [
        k("Login")
      ], !0)
    ]));
  }
});
const A = (r, e) => {
  const t = r.__vccOpts || r;
  for (const [n, s] of e)
    t[n] = s;
  return t;
}, y = /* @__PURE__ */ A(T, [["__scopeId", "data-v-e1ac1678"]]), L = /* @__PURE__ */ h({
  __name: "FusionAuthLogoutButton",
  setup(r) {
    const e = d();
    function t() {
      e.logout();
    }
    return (n, s) => (R(), m("button", {
      class: "logout-button",
      onClick: s[0] || (s[0] = (o) => t())
    }, [
      g(n.$slots, "default", {}, () => [
        k("Logout")
      ], !0)
    ]));
  }
});
const x = /* @__PURE__ */ A(L, [["__scopeId", "data-v-fb8f3354"]]), b = /* @__PURE__ */ h({
  __name: "FusionAuthRegisterButton",
  props: {
    state: {}
  },
  setup(r) {
    const e = d(), t = r;
    function n() {
      e.register(t.state);
    }
    return (s, o) => (R(), m("button", {
      class: "register-button",
      onClick: o[0] || (o[0] = (u) => n())
    }, [
      g(s.$slots, "default", {}, () => [
        k("Register")
      ], !0)
    ]));
  }
});
const S = /* @__PURE__ */ A(b, [["__scopeId", "data-v-6adc2447"]]), C = /* @__PURE__ */ h({
  __name: "RequireAuth",
  props: {
    withRole: {}
  },
  setup(r) {
    const e = r, { isLoggedIn: t, userInfo: n } = d(), s = E(() => {
      var f;
      if (!t.value || n.value === null)
        return !1;
      if (!e.withRole)
        return !0;
      const o = Array.isArray(e.withRole) ? e.withRole : [e.withRole], u = ((f = n.value) == null ? void 0 : f.roles) ?? [], a = t.value === !0, c = u.some((_) => o.includes(_));
      return a && c;
    });
    return (o, u) => s.value ? g(o.$slots, "default", { key: 0 }) : U("", !0);
  }
}), F = /* @__PURE__ */ h({
  __name: "RequireAnonymous",
  setup(r) {
    const { isLoggedIn: e } = d();
    return (t, n) => I(e) ? U("", !0) : g(t.$slots, "default", { key: 0 });
  }
}), $ = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  FusionAuthLoginButton: y,
  FusionAuthLogoutButton: x,
  FusionAuthRegisterButton: S,
  RequireAnonymous: F,
  RequireAuth: C
}, Symbol.toStringTag, { value: "Module" }));
var V = Object.defineProperty, B = (r, e, t) => e in r ? V(r, e, { enumerable: !0, configurable: !0, writable: !0, value: t }) : r[e] = t, i = (r, e, t) => (B(r, typeof e != "symbol" ? e + "" : e, t), t);
class H {
  constructor(e) {
    i(this, "serverUrl"), i(this, "clientId"), i(this, "redirectUri"), i(this, "scope"), i(this, "mePath"), i(this, "loginPath"), i(this, "registerPath"), i(this, "logoutPath"), i(this, "tokenRefreshPath"), this.serverUrl = e.serverUrl, this.clientId = e.clientId, this.redirectUri = e.redirectUri, this.scope = e.scope, this.mePath = e.mePath ?? "/app/me", this.loginPath = e.loginPath ?? "/app/login", this.registerPath = e.registerPath ?? "/app/register", this.logoutPath = e.logoutPath ?? "/app/logout", this.tokenRefreshPath = e.tokenRefreshPath ?? "/app/refresh";
  }
  getMeUrl() {
    return this.generateUrl(this.mePath);
  }
  getLoginUrl(e) {
    return this.generateUrl(this.loginPath, {
      client_id: this.clientId,
      redirect_uri: this.redirectUri,
      scope: this.scope,
      state: e
    });
  }
  getRegisterUrl(e) {
    return this.generateUrl(this.registerPath, {
      client_id: this.clientId,
      redirect_uri: this.redirectUri,
      scope: this.scope,
      state: e
    });
  }
  getLogoutUrl() {
    return this.generateUrl(this.logoutPath, {
      client_id: this.clientId,
      post_logout_redirect_uri: this.redirectUri
    });
  }
  getTokenRefreshUrl() {
    return this.generateUrl(this.tokenRefreshPath, {
      client_id: this.clientId
    });
  }
  generateUrl(e, t) {
    const n = new URL(this.serverUrl);
    if (n.pathname = e, t) {
      const s = this.generateURLSearchParams(t);
      n.search = s.toString();
    }
    return n;
  }
  generateURLSearchParams(e) {
    const t = new URLSearchParams();
    return Object.entries(e).forEach(([n, s]) => {
      s && t.append(n, s);
    }), t;
  }
}
class P {
  /**
   * Parses document.cookie for the access token expiration cookie value.
   * @returns {(number | null)} The moment of expiration in milliseconds since epoch.
   */
  static getAccessTokenExpirationMoment(e = "app.at_exp") {
    const t = document.cookie.split("; ").map((s) => s.split("=")).find(([s]) => s === e), n = t == null ? void 0 : t[1];
    return n ? parseInt(n) * 1e3 : null;
  }
}
class M {
  constructor(e) {
    i(this, "url"), this.url = e;
  }
  /** Refresh token a single time */
  async refreshToken() {
    const e = await fetch(this.url.href, {
      method: "POST",
      credentials: "include",
      headers: {
        "Content-Type": "text/plain"
      }
    });
    if (!(e.status >= 200 && e.status < 300))
      throw new Error("error refreshing access token in fusionauth");
  }
  /** Initializes continuous automatic token refresh. */
  initAutoRefresh(e = 10, t) {
    const n = P.getAccessTokenExpirationMoment(
      t
    );
    if (!n)
      return;
    const s = e * 1e3, o = (/* @__PURE__ */ new Date()).getTime(), u = n - s, a = Math.max(u - o, 0);
    return setTimeout(async () => {
      try {
        await this.refreshToken(), this.initAutoRefresh(e);
      } catch (c) {
        console.error(c);
      }
    }, a);
  }
}
class q {
  /**
   * Schedules a callback to be invoked at the given moment.
   * @param expirationMoment - the access token expiration moment in milliseconds since the epoch.
   * @param onExpiration - the callback to be invoked at the `expirationMoment`.
   */
  static scheduleTokenExpirationCallback(e, t) {
    const n = (/* @__PURE__ */ new Date()).getTime(), s = e - n;
    s > 0 && setTimeout(t, s);
  }
}
class j {
  constructor() {
    i(this, "REDIRECT_VALUE", "fa-sdk-redirect-value");
  }
  handlePreRedirect(e) {
    const t = `${this.generateRandomString()}:${e ?? ""}`;
    localStorage.setItem(this.REDIRECT_VALUE, t);
  }
  handlePostRedirect(e) {
    const t = this.stateValue ?? void 0;
    e == null || e(t), localStorage.removeItem(this.REDIRECT_VALUE);
  }
  get didRedirect() {
    return !!localStorage.getItem(this.REDIRECT_VALUE);
  }
  get stateValue() {
    const e = localStorage.getItem(this.REDIRECT_VALUE);
    if (!e)
      return null;
    const [, ...t] = e.split(":");
    return t.join(":");
  }
  generateRandomString() {
    const e = new Uint32Array(28);
    return window.crypto.getRandomValues(e), Array.from(
      e,
      (t) => ("0" + t.toString(16)).substring(-2)
    ).join("");
  }
}
class D {
  constructor(e) {
    i(this, "config"), i(this, "urlHelper"), i(this, "tokenRefresher"), i(this, "redirectHelper", new j()), this.config = e, this.urlHelper = new H({
      serverUrl: e.serverUrl,
      clientId: e.clientId,
      redirectUri: e.redirectUri,
      scope: e.scope,
      mePath: e.mePath,
      loginPath: e.loginPath,
      registerPath: e.registerPath,
      logoutPath: e.logoutPath,
      tokenRefreshPath: e.tokenRefreshPath
    }), this.tokenRefresher = new M(
      this.urlHelper.getTokenRefreshUrl()
    ), this.scheduleTokenExpirationEvent();
  }
  startLogin(e) {
    this.redirectHelper.handlePreRedirect(e), window.location.assign(this.urlHelper.getLoginUrl(e));
  }
  startRegister(e) {
    this.redirectHelper.handlePreRedirect(e), window.location.assign(this.urlHelper.getRegisterUrl(e));
  }
  startLogout() {
    window.location.assign(this.urlHelper.getLogoutUrl());
  }
  async fetchUserInfo() {
    const e = await fetch(this.urlHelper.getMeUrl(), {
      credentials: "include"
    });
    if (!e.ok)
      throw new Error(
        `Unable to fetch userInfo in fusionauth. Request failed with status code ${e == null ? void 0 : e.status}`
      );
    return await e.json();
  }
  async refreshToken() {
    return await this.tokenRefresher.refreshToken();
  }
  initAutoRefresh() {
    return this.tokenRefresher.initAutoRefresh(
      this.config.autoRefreshSecondsBeforeExpiry,
      this.config.accessTokenExpireCookieName
    );
  }
  handlePostRedirect(e) {
    this.isLoggedIn && this.redirectHelper.didRedirect && this.redirectHelper.handlePostRedirect(e);
  }
  get isLoggedIn() {
    return this.accessTokenExpirationMoment ? this.accessTokenExpirationMoment > (/* @__PURE__ */ new Date()).getTime() : !1;
  }
  get accessTokenExpirationMoment() {
    return P.getAccessTokenExpirationMoment(
      this.config.accessTokenExpireCookieName
    );
  }
  scheduleTokenExpirationEvent() {
    this.accessTokenExpirationMoment && this.config.onTokenExpiration && q.scheduleTokenExpirationCallback(
      this.accessTokenExpirationMoment,
      this.config.onTokenExpiration
    );
  }
}
const O = (r) => {
  const e = new D({
    ...r,
    onTokenExpiration: () => {
      t.value = !1;
    }
  }), t = p(e.isLoggedIn), n = p(null), s = p(!1), o = p(null);
  async function u() {
    s.value = !0, o.value = null;
    try {
      return n.value = await e.fetchUserInfo(), n.value;
    } catch (l) {
      o.value = l;
    } finally {
      s.value = !1;
    }
  }
  async function a() {
    return await e.refreshToken();
  }
  function c(l) {
    e.startLogin(l);
  }
  function f(l) {
    e.startRegister(l);
  }
  function _() {
    e.startLogout();
  }
  return r.shouldAutoFetchUserInfo && e.isLoggedIn === !0 && u(), r.shouldAutoRefresh && e.isLoggedIn === !0 && e.initAutoRefresh(), e.handlePostRedirect(r.onRedirect), {
    isLoggedIn: t,
    userInfo: n,
    getUserInfo: u,
    isGettingUserInfo: s,
    error: o,
    login: c,
    register: f,
    logout: _,
    refreshToken: a,
    initAutoRefresh: e.initAutoRefresh
  };
}, z = {
  install(r, e) {
    if (!e.clientId)
      throw new Error("clientId is required");
    if (!e.serverUrl)
      throw new Error("serverUrl is required");
    if (!e.redirectUri)
      throw new Error("redirectUri is required");
    r.provide(v, O(e)), Object.entries($).forEach(([t, n]) => {
      r.component(t, n);
    });
  }
};
export {
  y as FusionAuthLoginButton,
  x as FusionAuthLogoutButton,
  S as FusionAuthRegisterButton,
  F as RequireAnonymous,
  C as RequireAuth,
  z as default,
  d as useFusionAuth
};
